package com.sun.xml.internal.ws.api.server;

import javax.xml.ws.Provider;
import java.lang.reflect.InvocationTargetException;
import com.sun.xml.internal.ws.api.message.Packet;
import javax.xml.ws.WebServiceContext;
import com.sun.istack.internal.NotNull;
import java.lang.reflect.Method;

public abstract class Invoker extends com.sun.xml.internal.ws.server.sei.Invoker
{
    private static final Method invokeMethod;
    private static final Method asyncInvokeMethod;
    
    public Invoker() {
    }
    
    public void start(@NotNull WSWebServiceContext wsc, @NotNull WSEndpoint endpoint) {
        this.start(wsc);
    }
    
    @Deprecated
    public void start(@NotNull WebServiceContext wsc) {
        throw new IllegalStateException("deprecated version called");
    }
    
    public void dispose() {
    }
    
    public <T> T invokeProvider(@NotNull Packet p, T arg) throws IllegalAccessException, InvocationTargetException {
        return this.invoke(p, Invoker.invokeMethod, new Object[] { arg });
    }
    
    public <T> void invokeAsyncProvider(@NotNull Packet p, T arg, AsyncProviderCallback cbak, WebServiceContext ctxt) throws IllegalAccessException, InvocationTargetException {
        this.invoke(p, Invoker.asyncInvokeMethod, new Object[] { arg, cbak, ctxt });
    }
    
    static {
        try {
            invokeMethod = Provider.class.getMethod("invoke", new Class[] { Object.class });
        }
        catch (NoSuchMethodException e) {
            throw new AssertionError(e);
        }
        try {
            asyncInvokeMethod = AsyncProvider.class.getMethod("invoke", new Class[] { Object.class, AsyncProviderCallback.class, WebServiceContext.class });
        }
        catch (NoSuchMethodException e) {
            throw new AssertionError(e);
        }
    }
}
